## program to test two things ###### mb nm suggestion ###
## does an increase in number of constraint variables reduce TAE?
## are the variables not included in spat micr-sim predicted well?
##############
############# replace '/nfs/a237/gyeao' with 's:/gyeao'
#######
getwd() 
setwd("s:/gyeao")
rm(list=ls())
####################
install.packages("grid")
install.packages("gridExtra")
install.packages("data.tabl")
install.packages("mipfp")
install.packages("plyr")
install.packages("dplyr")
install.packages("ggplot2")# arrange ggplots in grids 3 by 3 etc # also tried package grid
install.packages("rgdal")#, lib="s:/gyeao/RLibs_4", repos="http://cran.rstudio.com/") # read shapefiles
install.packages("sms")
install.packages("maptools")
install.packages("rgdal")
install.packages("stringr")
install.packages("reshape2")
install.packages("lattice")
install.packages("cowplot")
install.packages("gtable")
install.packages("cumplyr")
install.packages("scales")
install.packages("RColorBrewer")

library(grid)
library(gridExtra)#, lib.loc="s:/gyeao/RLibs_4") 
library("data.table")#, lib.loc="s:/gyeao/RLibs_4")
library(mipfp)
library(plyr)
library(dplyr)
library(ggplot2)
library("rgdal")#, lib.loc="s:/gyeao/RLibs_4") # read shapefiles
library("sms")
library(maptools)
library(rgdal)
library(stringr)
library(reshape2)
library(lattice)
library(cumplyr)
library(scales)
library(RColorBrewer)
library(cowplot) # plot grid
library(gtable)
############################################
getwd()
#setwd("s:/gyeao/analysis_smicrosimulation/nrts_census/project")
#source("mb_nm_tests.R")
###############################################################
convert.magic<-function(obj,types){for(i in 1:length(obj)){FUN<-switch(types[i],c=as.character,n=as.numeric,f=as.factor);obj[,i]<-FUN(obj[,i])};obj}
############## read purpose ##################################################
purpose <- read.csv("analysis_smicrosimulation/nrts_census/results/Ind_level_nrts/ind_data_5.csv",header=T,stringsAsFactors=FALSE)  
purpose <- purpose[,c("Ind_ID","purpose")]

## s c comments ##
dada5 <- read.csv("s:/gyeao/results/mipf/adjusted data/dada5_mb_nm.csv",header=T,stringsAsFactors=FALSE,row.names = 2) 
  ind_data_wy_dada<-dada5[,-3]
    ind_data_wy_dada[ind_data_wy_dada=="car_No"]<-"car_0"; ind_data_wy_dada[ind_data_wy_dada=="over_65"]<-"Age65_"
      ind_data_wy_dada <- convert.magic(ind_data_wy_dada,c('n','c','c','c','c','c','c','c','c','c'))
        purpose <- convert.magic(purpose,c('n','c'))
          ind_data_wy_dada <- merge(ind_data_wy_dada,purpose,by.x = "X", by.y = "Ind_ID",all=F)
            ind_data_wy_dada <- ind_data_wy_dada[,-1]; ind_data_wy_dada <- ind_data_wy_dada[,c(1:2,10,3:9)]
colnames(ind_data_wy_dada)[colnames(ind_data_wy_dada)=="purpose"] <- "mode"
## end sc comments ###

#########  routines for stochastic stretegies - sms_sa, sms_hc, ga for variables ranging from 1 to 8 excluding resid, orig, destn ##################################################################################################
ind_data <- ind_data_wy_dada[,-2] ## ind_data <- ind_data_wy_dada[,-c(1:2)]

####### read in data the shapefile from Arcmap #
  shps <- dir(getwd(), "*.shp") # can also use function list.files (with search pattern)
    shps <- gsub("\\.shp$", "", shps) # strip.shp from end of filenames
      temp <- readOGR(dsn=path.expand("S:/gyeao/results/dump/ground"), layer="pc_area_wy")
        temp <- as.data.frame(temp); temp <- temp[,c(4,7)]
 
ind_data_area <- merge(ind_data, temp, by.x = "Residence_PC", by.y = "com_sect")     
  ind_data_area$Residence_PC <- ind_data_area$postarea; ind_data_area <- ind_data_area[,-10]      
    ind_data_area <- convert.magic(ind_data_area,c('c','c','c','c','c','c','c','c','c'))
  
census_ref <- data.frame(matrix(ncol = 1, nrow = nrow(ind_data_area))) # create empty dataframe
  for(i in 2:ncol(ind_data_area)){cat <- model.matrix(~ ind_data_area[,i] - 1); census_ref <- cbind(cat,census_ref)} # re-modelling matrices
    census_model_matrix <- census_ref[,-ncol(census_ref)] # remove nuisance row created with empty dataframe
      names(census_model_matrix) <- substring(names(census_model_matrix), 19) # start from 17th character
      
census_model_matrix$Residence_PC <- ind_data_area$Residence_PC; census_model_matrix <- census_model_matrix[,c(28,1:27)]
  census <- aggregate(.~Residence_PC, census_model_matrix, FUN=sum) # creates a data frame of structure used in sms - dimitris
    colnames(census)[1] <- "areaid"; census$population <- rowSums(census[,c(2:3)]); census <- census[,c(1,29,2:28)]
  
# sample for survey data in sms-dimitris
  set.seed(1500) # also set near line 96
    survey <- census_model_matrix[sample(nrow(census_model_matrix), round(0.7*nrow(census_model_matrix))), ]
      survey <- survey[,-1]; survey <- setDT(survey, keep.rownames = TRUE)[]
        colnames(survey)[1] <- "pid"
      
in.lexicon <- createLexicon()
  for(i in 2:length(names(survey))){in.lexicon <- addDataAssociation(in.lexicon, c(paste(colnames(survey)[i]), paste(colnames(survey)[i])))}
    
mysms <- new("microsimulation", iterations = 90, census = census, panel = survey, lexicon = in.lexicon)
myseed <- 1800

try02 <- run_parallel_SA(insms = mysms, inseed = myseed) # when run parallel is in series use try02[[i]]['selection'] instead of with try02@results[[i]]['selection']
#for(i in 1:nrow(census)){as.data.frame(assign(paste("z",census[i,1],sep=""), try02@results[[i]])['selection']) %>% write.csv(paste("s:/gyeao/results/comb-optim/no_adjustments/","z_",census[i,1],".csv",sep=""),quote=TRUE,na="NA",row.names=TRUE)}
  for(i in 1:nrow(census)){empty<-as.data.frame(try02@results[[i]]['selection']); empty$t123456789areaid<-census[i,1]; if(i==1){sim_pop<-empty[0,];sim_pop<-empty}else{ sim_pop<-rbind(sim_pop,empty) } }
    names(sim_pop) <- substring(names(sim_pop), 11)
      sim_pop$population <- 0; sim_pop <- sim_pop[,c(29,30,2:28)]

sim_pop_v2 <- aggregate(.~areaid, sim_pop, FUN=sum) # creates a structure suitable for comparison with census
sim_pop_v2$population <- rowSums(sim_pop_v2[,c(3:4)])

### difference in dataframes ##
diff <- census; for(i in 1:nrow(census)){for(j in 3:ncol(census)){diff[i,j]<-(abs(sim_pop_v2[i,j]-census[i,j])) }}
diff <- diff[order(-diff$population),]; jagdesh <- as.data.frame(diff[,c(1:2)])

for(i in 1:nrow(diff)){for(j in 3:ncol(diff)){diff[i,j]<- diff[i,j]/diff[i,2]  }} # divide by population of zone

diff$areaid <- as.character(diff$areaid); diff$areaid <- factor(diff$areaid, levels=unique(diff$areaid))

diff <- diff[,-2]
df <- melt(diff ,  id.vars = 'areaid', variable.name = 'series') ; df$value <- log(df$value+0.0) # df$value <- df$value  #
#ggplot(df, aes(areaid,value)) + geom_line(size=1,aes(colour = series, group = series)) 

## http://www.cookbook-r.com/Graphs/Colors_%28ggplot2%29/#colors-ggplot2
cbbPalette <- c("#D55E00","#D55E00","#56B4E9","#56B4E9","red","red","red","red","#009E73","#009E73","#009E73","#009E73","#F0E442","#F0E442","#0072B2","#0072B2","#0072B2","#0072B2","#000000","#000000","#000000","#000000","#000000","#000000","#000000","#999999","#999999")
h <- ggplot(df, aes(areaid,value)) + geom_line(size=1,aes(colour = series, group = series)) + scale_color_manual(values=cbbPalette) # gooooood

dev.off()
dif_v2 <- diff
row.names(dif_v2) <- dif_v2$areaid
dif_v2 <- dif_v2[,2:28]
diff_matrix <- data.matrix(dif_v2)
#nba_heatmap <- heatmap(nba_matrix, Rowv=NA, Colv=NA, col = brewer.pal(9, "Blues"), scale="column", margins=c(5,10))
#nba_heatmap <- heatmap(nba_matrix, Rowv=NA, Colv=NA, col = cm.colors(256), scale="column", margins=c(5,10))
#diff_heatmap <- heatmap(t(diff_matrix), Rowv=NA, Colv=NA, col = heat.colors(1028), scale="column", margins=c(5,10))


#ggplot(data=df, aes(x=areaid, y=series, fill=value)) + geom_tile()+ scale_fill_gradient2(low = "green", mid = "white", high = "darkred") # gooood - gradient"2" also gradient

#ggplot(df, aes(x=areaid, y=series, fill=value)) + geom_raster() + scale_fill_gradientn(colours = terrain.colors(10),na.value = "transparent", breaks=c(0,3,6),labels=c("Minimum",3,"Maximum"), limits=c(0,6))
#ggplot(df, aes(x=areaid, y=series, fill=value)) + geom_raster() + scale_fill_gradientn(colours = rainbow(7),na.value = "transparent", breaks=c(0,3,6),labels=c("Minimum",3,"Maximum"), limits=c(0,6))

#ggplot(data=df, aes(x=areaid, y=series, fill=value)) +
#  geom_raster() +
#  scale_fill_gradientn(colours=c('grey', 'yellow', 'cyan', 'blue','green', 'violet', 'orange', 'red'),na.value = "transparent",
#                       values   = c(0.0,0.75,1.5,2.25,3.0,3.75,4.5,5.25),
#                       breaks   = c(0.0,0.75,1.5,2.25,3.0,3.75,4.5,5.25),
#                       rescaler = function(x,...) x,
#                       oob      = identity)

g<-ggplot(data=df, aes(x=areaid, y=series, fill=value)) +
  geom_raster() +
  scale_fill_gradientn(colours = c('black', 'darkred', 'red', 'orange', 'green', 'yellow' ), na.value = "transparent", ## 'yellow', 'green', 'orange', 'red', 'darkred', 'black'##  )
                       values   = c(0.0,-3.0,-4.0,-5.0,-6.0,-8.0), # c(0.0,3.0,4.0,5.0,6.0,8.0), # 
                       breaks   = c(0.0,-3.0,-4.0,-5.0,-6.0,-8.0), # c(0.0,3.0,4.0,5.0,6.0,8.0), # 
                       rescaler = function(x,...) x,
                       oob      = identity) # colors http://www.stat.columbia.edu/~tzheng/files/Rcolor.pdf

## nanna ananana
grid.newpage() # http://stackoverflow.com/questions/27929452/r-return-corrplot-as-object/27948707#27948707
# grid.arrange(h,g,ncol=1,nrow=2, widths=0.5:1) # 

## this way!!
g2 <- ggplotGrob(h)
  g3 <- ggplotGrob(g)
    g <- rbind(g2, g3, size="first")
      g$widths <- unit.pmax(g2$widths, g3$widths)
        grid.newpage();grid.draw(g)


## end program 

