## program to test two things ###### mb nm suggestion ###
## does an increase in number of constraint variables reduce TAE?
## are the variables not included in spat micr-sim predicted well?
##############
############# replace '/nfs/a237/gyeao' with 's:/gyeao'
#######
getwd() 
setwd("s:/gyeao")
rm(list=ls())
####################
install.packages("grid")
install.packages("gridExtra")
install.packages("data.tabl")
install.packages("mipfp")
install.packages("plyr")
install.packages("dplyr")
install.packages("ggplot2")# arrange ggplots in grids 3 by 3 etc # also tried package grid
install.packages("rgdal")#, lib="s:/gyeao/RLibs_4", repos="http://cran.rstudio.com/") # read shapefiles
install.packages("sms")
install.packages("maptools")
install.packages("rgdal")
install.packages("stringr")
install.packages("reshape2")
install.packages("lattice")
install.packages("cowplot")
install.packages("gtable")
install.packages("cumplyr")
install.packages("scales")
install.packages("RColorBrewer")

library(grid)
library(gridExtra)#, lib.loc="s:/gyeao/RLibs_4") 
library("data.table")#, lib.loc="s:/gyeao/RLibs_4")
library(mipfp)
library(plyr)
library(dplyr)
library(ggplot2)
library("rgdal")#, lib.loc="s:/gyeao/RLibs_4") # read shapefiles
library("sms")
library(maptools)
library(rgdal)
library(stringr)
library(reshape2)
library(lattice)
library(cumplyr)
library(scales)
library(RColorBrewer)
library(cowplot) # plot grid
library(gtable)
############################################
getwd()
#setwd("s:/gyeao/analysis_smicrosimulation/nrts_census/project")
#source("mb_nm_tests.R")
###############################################################
convert.magic<-function(obj,types){for(i in 1:length(obj)){FUN<-switch(types[i],c=as.character,n=as.numeric,f=as.factor);obj[,i]<-FUN(obj[,i])};obj}
############## read purpose ##################################################
purpose <- read.csv("analysis_smicrosimulation/nrts_census/results/Ind_level_nrts/ind_data_5.csv",header=T,stringsAsFactors=FALSE)  
purpose <- purpose[,c("Ind_ID","purpose")]

## s c comments ##
dada5 <- read.csv("s:/gyeao/results/mipf/adjusted data/dada5_mb_nm.csv",header=T,stringsAsFactors=FALSE,row.names = 2) 
  ind_data_wy_dada<-dada5[,-3]
    ind_data_wy_dada[ind_data_wy_dada=="car_No"]<-"car_0"; ind_data_wy_dada[ind_data_wy_dada=="over_65"]<-"Age65_"
      ind_data_wy_dada <- convert.magic(ind_data_wy_dada,c('n','c','c','c','c','c','c','c','c','c'))
        purpose <- convert.magic(purpose,c('n','c'))
          ind_data_wy_dada <- merge(ind_data_wy_dada,purpose,by.x = "X", by.y = "Ind_ID",all=F)
            ind_data_wy_dada <- ind_data_wy_dada[,-1]; ind_data_wy_dada <- ind_data_wy_dada[,c(1:2,10,3:9)]
colnames(ind_data_wy_dada)[colnames(ind_data_wy_dada)=="purpose"] <- "mode"
## end sc comments ###

#paper.table <- ind_data_wy_dada[,-2]
#write.csv(paper.table,paste("s:/gyeao/results/deterministic/paper_table",".csv",sep=""),quote=TRUE,na="NA",row.names=TRUE)

#########  routines for stochastic stretegies - sms_sa, sms_hc, ga for variables ranging from 1 to 8 excluding resid, orig, destn ##################################################################################################
ind_data <- ind_data_wy_dada[,-2] ## ind_data <- ind_data_wy_dada[,-c(1:2)]

####### read in data the shapefile from Arcmap # convert postcode sectors to areas
  shps <- dir(getwd(), "*.shp") # can also use function list.files (with search pattern)
    shps <- gsub("\\.shp$", "", shps) # strip.shp from end of filenames
      temp <- readOGR(dsn=path.expand("S:/gyeao/results/dump/ground"), layer="pc_area_wy")
        temp <- as.data.frame(temp); temp <- temp[,c(4,7)]
 
ind_data_area <- merge(ind_data, temp, by.x = "Residence_PC", by.y = "com_sect")     
  ind_data_area$Residence_PC <- ind_data_area$postarea; ind_data_area <- ind_data_area[,-10]      
    ind_data_area <- convert.magic(ind_data_area,c('c','c','c','c','c','c','c','c','c'))
    
# implements mipfp according to johan barthelemy ##
    #######
    empty3.df <- data.frame(matrix(NA, nrow = 0, ncol = 3)); names(empty3.df) <- c('areaid','series','value')
    for (e in 1:15){    # was 1:15
      
      empty2.df <- data.frame(matrix(NA, nrow = 0, ncol = 3)); names(empty2.df) <- c('areaid','series','value')
      
      #for(k in 1:4){if(k==1){m<-0.0005}else{if(k==2){m<-0.005}else{if(k==3){m<-0.05}else{if(k==4){m<-0.75}else{}}}}    
      for(k in 1:1){if(k==1){m<-0.7}else{if(k==2){m<-0.65}else{if(k==3){m<-0.75}else{if(k==4){m<-0.85}else{}}}}    
        
        empty.df <- data.frame(matrix(NA, nrow = 0, ncol = 9)); names(empty.df) <- names(ind_data_area)    
        
        seed.data <- ind_data_area[,-1]
        seed.df <- seed.data[sample(nrow(seed.data), round(m*nrow(seed.data))), ]
        seed.table <- table(seed.df)
        
        true.table <- table(ind_data_area)  
        tgt.data <- list()
        for(i in 1:nrow(true.table)){tgt<- true.table[i,,,,,,,,]
        tgt.v <- apply(tgt, c(1,2,3,4,5,6,7,8), sum)
        tgt.l.dims <- list(c(1,2,3,4,5,6,7,8))
        tgt.data[i]  <- list(tgt.v)
        
        mipf <- Estimate(seed=seed.table, target.list=tgt.l.dims, target.data=tgt.data[i])  
        
        #http://stackoverflow.com/questions/9931241/r-how-do-i-retrieve-a-matrix-column-and-row-name-by-a-matrix-index-value    
        sim.pop <- expand(mipf[[1]]); 
        nam <- arrayInd(i, dim(true.table)); name <- rownames(true.table)[nam[,1]]; sim.pop$Residence_PC <- paste(name,sep=""); sim.pop <- sim.pop[,c(9,1:8)]
        empty.df <- rbind(empty.df,sim.pop) #; print(k)
        }    
        sim.pop  <- empty.df
        sim.popln <- sim.pop
        
        #create a simulated population structure for comparison 
        sim_ref <- data.frame(matrix(ncol = 1, nrow = nrow(sim.popln))) # create empty dataframe
        for(i in 2:ncol(sim.popln)){cat <- model.matrix(~ sim.popln[,i] - 1); sim_ref <- cbind(cat,sim_ref)} # re-modelling matrices
        sim_model_matrix <- sim_ref[,-ncol(sim_ref)] # remove nuisance row created with empty dataframe
        names(sim_model_matrix) <- substring(names(sim_model_matrix), 15) # start from 17th character
        sim_model_matrix$Residence_PC <- sim.popln$Residence_PC; sim_model_matrix <- sim_model_matrix[,c(28,1:27)]
        sim <- aggregate(.~Residence_PC, sim_model_matrix, FUN=sum) # creates a data frame of structure used in sms - dimitris
        colnames(sim)[1] <- "areaid"; sim$population <- rowSums(sim[,c(2:3)]); sim <- sim[,c(1,29,2:28)]
        sim <- sim[order(-sim$population),]
        sim$areaid <- as.character(sim$areaid); sim$areaid <- factor(sim$areaid, levels=unique(sim$areaid))
        
        #create a census population structure for comparison 
        census_ref <- data.frame(matrix(ncol = 1, nrow = nrow(ind_data_area))) # create empty dataframe
        for(i in 2:ncol(ind_data_area)){cat <- model.matrix(~ ind_data_area[,i] - 1); census_ref <- cbind(cat,census_ref)} # re-modelling matrices
        census_model_matrix <- census_ref[,-ncol(census_ref)] # remove nuisance row created with empty dataframe
        names(census_model_matrix) <- substring(names(census_model_matrix), 19) # start from 17th character
        census_model_matrix$Residence_PC <- ind_data_area$Residence_PC; census_model_matrix <- census_model_matrix[,c(28,1:27)]
        census <- aggregate(.~Residence_PC, census_model_matrix, FUN=sum) # creates a data frame of structure used in sms - dimitris
        colnames(census)[1] <- "areaid"; census$population <- rowSums(census[,c(2:3)]); census <- census[,c(1,29,2:28)]
        census <- census[order(-census$population),]
        census$areaid <- as.character(census$areaid); census$areaid <- factor(census$areaid, levels=unique(census$areaid))
        
        ### difference in dataframes ##
        diff <- census; for(i in 1:nrow(census)){for(j in 3:ncol(census)){diff[i,j]<-(abs(sim[i,j]-census[i,j])) }}
        for(i in 1:nrow(diff)){for(j in 3:ncol(diff)){diff[i,j]<- diff[i,j]/diff[i,2]  }} # divide by population of zone
        
        diff <- diff[,-2]
        df <- melt(diff ,  id.vars = 'areaid', variable.name = 'series') ; df$value <- log(df$value+0.0) # df$value <- df$value  #
        
        #df$logTAE <- paste('100x',m,'%',sep=''); df <- df[,c(4,3,1,2)]; df <- df[,-c(3,4)]; names(df) <- c('Sample.Ratio','logTAE')
        df$areaid <- as.character(df$areaid); df$areaid <- factor(df$areaid, levels=unique(df$areaid))
        
        empty2.df <- rbind(empty2.df,df) # end of for loop 
        
      } # end of for loop line 85 
      df3 <- rbind(empty3.df, empty2.df); print(e)}
    df <- df3
    #df <- empty2.df
 
  
## http://www.cookbook-r.com/Graphs/Colors_%28ggplot2%29/#colors-ggplot2
cbbPalette <- c("#D55E00","#D55E00","#56B4E9","#56B4E9","red","red","red","red","#009E73","#009E73","#009E73","#009E73","#F0E442","#F0E442","#0072B2","#0072B2","#0072B2","#0072B2","#000000","#000000","#000000","#000000","#000000","#000000","#000000","#999999","#999999")
h <- ggplot(df, aes(areaid,value)) + geom_line(size=1,aes(colour = series, group = series)) + scale_color_manual(values=cbbPalette) # gooooood

dev.off()
dif_v2 <- diff
row.names(dif_v2) <- dif_v2$areaid
dif_v2 <- dif_v2[,2:28]
diff_matrix <- data.matrix(dif_v2)

g<-ggplot(data=df, aes(x=areaid, y=series, fill=value)) +
  geom_raster() +
  scale_fill_gradientn(colours = c('black', 'darkred', 'red', 'orange', 'green', 'yellow' ), na.value = "transparent", #### c('yellow', 'green', 'orange', 'red', 'darkred', 'black' ) ## c('black', 'darkred', 'red', 'orange', 'green', 'yellow' )
                       values   = c(0.0,-3.0,-4.0,-5.0,-6.0,-8.0), #c(0.0,3.0,4.0,5.0,6.0,8.0), # 
                       breaks   = c(0.0,-3.0,-4.0,-5.0,-6.0,-8.0), #c(0.0,3.0,4.0,5.0,6.0,8.0), # 
                       rescaler = function(x,...) x,
                       oob      = identity) # colors http://www.stat.columbia.edu/~tzheng/files/Rcolor.pdf

## nanna ananana
grid.newpage() # http://stackoverflow.com/questions/27929452/r-return-corrplot-as-object/27948707#27948707
#grid.arrange(h,g,ncol=1,nrow=2, widths=0.5:1)#

## this way!!
g2 <- ggplotGrob(h)
  g3 <- ggplotGrob(g)
    g <- rbind(g2, g3, size="first")
      g$widths <- unit.pmax(g2$widths, g3$widths)
        grid.newpage();grid.draw(g)


## end program 

